apiVersion: {{ deployment_apivers }}
kind: {{ deployment_kind }}
metadata:
  labels:
{% if do_backups %}
    backups.opsperator.io/driver: ssh
{% if (backups_interval | default('daily')) == 'hourly' %}
    backups.opsperator.io/interval: hourly
    backups.opsperator.io/preferredtime: "{{ backups_hourly_start_minute | default(15)}}"
{% elif (backups_interval | default('daily')) == 'weekly' %}
    backups.opsperator.io/interval: weekly
    backups.opsperator.io/preferredtime: "{{ backups_weekly_start_day | default(0) }}"
{% else %}
    backups.opsperator.io/interval: daily
    backups.opsperator.io/preferredtime: "{{ backups_daily_start_hour | default(2) }}"
{% endif %}
    backups.opsperator.io/secret: backups-{{ gerrit_name }}
    backups.opsperator.io/service: backups-{{ gerrit_name }}
{% endif %}
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ gerrit_name }}
  name: {{ gerrit_name }}
  namespace: {{ namespace }}
spec:
  replicas: 1
  revisionHistoryLimit: {{ deploy_revision_history_limit | default(10) }}
  selector:
{% if deployment_kind != 'DeploymentConfig' %}
    matchLabels:
      name: {{ gerrit_name }}
  strategy:
    type: Recreate
{% else %}
    name: {{ gerrit_name }}
  strategy:
    recreateParams:
      timeoutSeconds: 900
    resources:
      limits:
        cpu: {{ deploy_pod_cpu_limit }}
        memory: {{ deploy_pod_memory_limit }}
      requests:
        cpu: {{ deploy_pod_cpu_request }}
        memory: {{ deploy_pod_memory_request }}
    type: Recreate
{% endif %}
  template:
    metadata:
      labels:
        name: {{ gerrit_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values:
                - {{ gerrit_name }}
                - {{ gerrit_name }}-slave
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values:
                  - {{ gerrit_name }}
                  - {{ gerrit_name }}-slave
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: DB_DRIVER
          value: {{ gerrit_db_type }}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
{% if gerrit_db_type in [ 'mariadb', 'mysql' ] %}
        - name: MYSQL_HOST
          value: {{ gerrit_ms_name }}
{% elif gerrit_db_type == 'postgres' %}
        - name: POSTGRES_HOST
          value: {{ gerrit_pg_name }}
{% endif %}
        - name: TZ
          value: {{ timezone }}
{% if do_triggers == False or (opsimages | json_query("[?name=='gerrit'].short"))[0] == False %}
        image: {{ (opsimages | json_query("[?name=='gerrit'].image"))[0] }}
{% endif %}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 38
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 8080
          timeoutSeconds: 3
        name: gerrit
        ports:
        - containerPort: 8080
        - containerPort: 29418
        readinessProbe:
          failureThreshold: 5
          initialDelaySeconds: 60
          periodSeconds: 60
          tcpSocket:
            port: 8080
          timeoutSeconds: 3
        resources:
          limits:
            cpu: "{{ gerrit_cpu_limit }}"
            memory: "{{ gerrit_memory_limit }}"
          requests:
            cpu: "{{ gerrit_cpu_request }}"
            memory: "{{ gerrit_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 38
          initialDelaySeconds: 30
          periodSeconds: 15
          tcpSocket:
            port: 8080
{% endif %}
        volumeMounts:
{% if do_ldap and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /config
          name: config
{% if do_ldap %}
        - mountPath: /etc/ldap
          name: ldapconf
{% endif %}
        - mountPath: /var/gerrit/.gerritcodereview
          name: data
          subPath: codereview
        - mountPath: /var/gerrit/data
          name: data
          subPath: data
        - mountPath: /var/gerrit/cache
          name: data
          subPath: cache
        - mountPath: /var/gerrit/db
          name: data
          subPath: db
        - mountPath: /var/gerrit/etc
          name: data
          subPath: etc
        - mountPath: /var/gerrit/git
          name: data
          subPath: git
        - mountPath: /var/gerrit/index
          name: data
          subPath: index
        - mountPath: /var/gerrit/lib
          name: data
          subPath: lib
        - mountPath: /var/gerrit/plugins
          name: data
          subPath: plugins
        - mountPath: /var/gerrit/tmp
          name: data
          subPath: tmp
        - mountPath: /.ssh/id_rsa.pub
          name: sshkey
          subPath: id_rsa.pub
        - mountPath: /.ssh/id_rsa
          name: sshkey
          subPath: id_rsa
{% if do_backups %}
{% if do_triggers == False or (opsimages | json_query("[?name=='sshd'].short"))[0] == False %}
      - image: {{ (opsimages | json_query("[?name=='sshd'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
{% else %}
      - imagePullPolicy: {{ pull_policy }}
{% endif %}
        livenessProbe:
          initialDelaySeconds: 30
          tcpSocket:
            port: 2222
          timeoutSeconds: 3
        name: sshd
        ports:
        - containerPort: 2222
        resources:
          limits:
            cpu: {{ sshd_cpu_limit }}
            memory: {{ sshd_memory_limit }}
          requests:
            cpu: "{{ sshd_cpu_request }}"
            memory: "{{ sshd_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /home/backup
          name: tmp
          subPath: bkphome
        - mountPath: /var/backup
          name: tmp
          subPath: bkpvar
        - mountPath: /.ssh/id_rsa.pub
          name: backupkey
          subPath: id_rsa.pub
        - mountPath: /backups
          name: data
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-application
{% endif %}
{% if rwo_needs_fsgroup | default(False) %}
      securityContext:
        fsGroup: {{ rwo_needs_fsgroup }}
{% else %}
      securityContext: {}
{% endif %}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ gerrit_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
      - labelSelector:
          matchLabels:
            name: {{ gerrit_name }}-slave
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
{% if do_backups %}
      - name: backupkey
        secret:
          secretName: backups-{{ gerrit_name }}
{% endif %}
      - name: config
        secret:
          defaultMode: 0420
          secretName: {{ gerrit_name }}-master
      - name: data
        persistentVolumeClaim:
          claimName: {{ gerrit_name }}
{% if do_ldap %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% if k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% endif %}
      - name: sshkey
        secret:
          secretName: {{ gerrit_name }}-ssh
      - emptyDir: {}
        name: tmp
{% if do_triggers %}
  triggers:
{% if (opsimages | json_query("[?name=='gerrit'].short"))[0] %}
  - type: ImageChange
    imageChangeParams:
      automatic: true
      containerNames:
      - gerrit
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='gerrit'].short"))[0] }}
        namespace: {{ buildns }}
{% endif %}
{% if do_backups and (opsimages | json_query("[?name=='sshd'].short"))[0] %}
  - imageChangeParams:
      automatic: true
      containerNames:
      - sshd
      from:
        kind: ImageStreamTag
        name: {{ (opsimages | json_query("[?name=='sshd'].short"))[0] }}
        namespace: {{ buildns }}
    type: ImageChange
{% endif %}
  - type: ConfigChange
{% endif %}
